package cn.rankin.apiweb.controller;

import cn.rankin.apiweb.assist.resolver.NeedUser;
import cn.rankin.apiweb.service.tag.TagService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.app.vo.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
public class TagController {

    @Autowired
    private TagService tagService;

    @RequestMapping(value = "/tagGroup/{code}", method = RequestMethod.GET)
    public APIResult<TagGroupVo> getTagGroup(@NeedUser DeviceUserVo user, @PathVariable("code") String code) {
        String merchantId = user.getMerchantId();
        return tagService.findTagGroupByCode(code, merchantId);
    }

    @RequestMapping(value = "/tag/{tagId}", method = RequestMethod.GET)
    public APIResult<Page<ItemVo>> findItemByTagId(@NeedUser DeviceUserVo user, @PathVariable("tagId") String tagId,
                                                   @RequestParam("pageNo") Integer pageNo, @RequestParam("pageSize") Integer pageSize) {
        String merchantId = user.getMerchantId();
        return tagService.findPageByTagId(tagId, merchantId, pageNo, pageSize);
    }

    @RequestMapping(value = "/tagType/{code}", method = RequestMethod.GET)
    public APIResult<List<TagVo>> getTagType(@NeedUser DeviceUserVo user,@PathVariable("code") String code) {
        String merchantId = user.getMerchantId();
        return tagService.findTagTypeByCode(code, merchantId);
    }

}
